#region GNU_GPL
// Copyright (c) 2003 The Ohio State University
//
// Anish Arora <anish@cis.ohio-state.edu>
// Jason Hallstrom <hallstro@cis.ohio-state.edu>
// Bill Leal <leal@cis.ohio-state.edu>
//
// This file is part of DRSS.
//
// DRSS is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// DRSS is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with DRSS; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#endregion


using System;
using System.Collections;
using System.Reflection;


namespace OSU.DRSS.ExternalizingObject
{

	[Serializable]
	public abstract class ExternalizingObjectBase : MarshalByRefObject, ExternalizingObject
	{
		#region Constructors
		//-----------------------------------------------------------------
		// Constructors
		//-----------------------------------------------------------------		
		public ExternalizingObjectBase()
		{}
		//-----------------------------------------------------------------		
		#endregion


		#region Properties
		//-----------------------------------------------------------------		
		// Properties
		//-----------------------------------------------------------------		
		public Hashtable Representation
		{	
			get
			{
				//---
				// Query the fields of the object and build a hashtable 
				// mapping field name to field value
				FieldInfo []fiFields = this.GetType().GetFields(BindingFlags.Public | BindingFlags.NonPublic | BindingFlags.Instance);
				Hashtable htRepresentation = new Hashtable();
				for(int intIndex = 0; intIndex < fiFields.Length; intIndex++)
				{	htRepresentation.Add(fiFields[intIndex].Name, fiFields[intIndex].GetValue(this));	}
				//---

				return(htRepresentation);
			}
			
			set
			{
				//---
				// Update each object field based on the key/value pairs
				// in the hashtable				
				foreach(DictionaryEntry deEntry in value)
				{
					FieldInfo fiField = this.GetType().GetField((string) deEntry.Key, BindingFlags.Public | BindingFlags.NonPublic | BindingFlags.Instance);
					fiField.SetValue(this, deEntry.Value);
				}
				//---
			}
		}
		//-----------------------------------------------------------------		
		#endregion
	}

}
