#region GNU_GPL
// Copyright (c) 2003 The Ohio State University
//
// Anish Arora <anish@cis.ohio-state.edu>
// Jason Hallstrom <hallstro@cis.ohio-state.edu>
// Bill Leal <leal@cis.ohio-state.edu>
//
// This file is part of DRSS.
//
// DRSS is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// DRSS is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with DRSS; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#endregion


using System;


namespace OSU.DRSS.ManagedObjects
{

	[Serializable]
	public class ManagedObjectInformation
	{
		#region Fields
		//-----------------------------------------------------------------
		// Fields
		//-----------------------------------------------------------------		
		// The object's globally unique ID
		private Guid guiObjectID;
		
		// The object's human-readable name
		private string strName;

		// The object's human-readable description
		private string strDescription;

		// The object's behavioral specification
		private object objSpecification;
		//-----------------------------------------------------------------
		#endregion


		#region Constructors
		//-----------------------------------------------------------------		
		// Constructors
		//-----------------------------------------------------------------		
		public ManagedObjectInformation(Guid guiObjectID, string strName, string strDescription, object objSpecification)
		{
			this.guiObjectID = guiObjectID;
			this.strName = strName;
			this.strDescription = strDescription;
			this.objSpecification = objSpecification;
		}
		//-----------------------------------------------------------------		
		#endregion


		#region Properties
		//-----------------------------------------------------------------		
		// Properties
		//-----------------------------------------------------------------		
		public Guid ObjectID
		{
			get
			{	return(guiObjectID);   }
		}

		public string Name
		{	
			get
			{	return(strName);   }
		}

		public string Description
		{	
			get
			{	return(strDescription);   }
		}

		public object Specification
		{	
			get
			{	return(objSpecification);   }
		}
		//-----------------------------------------------------------------		
		#endregion


		#region Methods
		//-----------------------------------------------------------------
		// Methods
		//-----------------------------------------------------------------		
		public override string ToString()
		{
			string strResult = "Object ID: [" + guiObjectID + "] ; Name: [" + strName + "] ; " +
				               "Description: [" + strDescription + "] ; Specification: [" + objSpecification + "]";
			return(strResult);
		}
		//-----------------------------------------------------------------		
		#endregion
	}

}
