#region GNU_GPL
// Copyright (c) 2003 The Ohio State University
//
// Anish Arora <anish@cis.ohio-state.edu>
// Jason Hallstrom <hallstro@cis.ohio-state.edu>
// Bill Leal <leal@cis.ohio-state.edu>
//
// This file is part of DRSS.
//
// DRSS is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// DRSS is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with DRSS; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#endregion


using System;


namespace OSU.DRSS.Platform
{

	public delegate void InterceptorUnregisteredEventDelegate(object objSource, InterceptorUnregisteredEventArgs iueArgs);


	[Serializable]
	public class InterceptorUnregisteredEventArgs : EventArgs
	{
		#region Fields
		//-----------------------------------------------------------------
		// Fields
		//-----------------------------------------------------------------
		// The chain ID corresponding to the chain from which the interceptor
		// was removed
		private Guid guiChainID;

		// The interceptor's (previous) chain index 
		private int intIndex;
		//-----------------------------------------------------------------
		#endregion


		#region Constructors
		//-----------------------------------------------------------------		
		// Constructors
		//-----------------------------------------------------------------		
		public InterceptorUnregisteredEventArgs(Guid guiChainID, int intIndex)
		{
			this.guiChainID = guiChainID;
			this.intIndex = intIndex;
		}
		//-----------------------------------------------------------------		
		#endregion


		#region Properties
		//-----------------------------------------------------------------		
		// Properties
		//-----------------------------------------------------------------	
		public Guid ChainID
		{
			get
			{	return(guiChainID);   }
		}

		public int Index
		{
			get
			{	return(intIndex);   }
		}
		//-----------------------------------------------------------------	
		#endregion


		#region Methods
		//-----------------------------------------------------------------
		// Methods
		//-----------------------------------------------------------------		
		public override string ToString()
		{	return("Unregistered Interceptor: [Chain: [" + guiChainID + "]; Index: [" + intIndex + "]]");   }
		//-----------------------------------------------------------------		
		#endregion
	}

}
