#region GNU_GPL
// Copyright (c) 2003 The Ohio State University
//
// Anish Arora <anish@cis.ohio-state.edu>
// Jason Hallstrom <hallstro@cis.ohio-state.edu>
// Bill Leal <leal@cis.ohio-state.edu>
//
// This file is part of DRSS.
//
// DRSS is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// DRSS is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with DRSS; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#endregion


using System;
using OSU.DRSS.ManagedObjects;
using OSU.DRSS.Platform.Messaging.Transport;


namespace OSU.DRSS.Platform.Messaging.Interception
{

	[Serializable]
	public abstract class ReceiveInterceptor : ManagedObjectBase
	{
		#region Fields
		//-----------------------------------------------------------------
		// Fields
		//-----------------------------------------------------------------		
		// The interceptor's content consumer ID, which should match the content provider
		// ID of the provider whose content is recognized by the interceptor.  This field may 
		// be set to Guid.Empty to indicate that the interceptor does not rely on content from 
		// a particular provider
		protected Guid guiContentConsumerID;
		//-----------------------------------------------------------------		
		#endregion


		#region Constructors
		//-----------------------------------------------------------------		
		// Constructors
		//-----------------------------------------------------------------		
		public ReceiveInterceptor(string strName, string strDescription, object objSpecification)
			: base(strName, strDescription, objSpecification)
		{}
		//-----------------------------------------------------------------		
		#endregion


		#region Properties
		//-----------------------------------------------------------------		
		// Properties
		//-----------------------------------------------------------------	
		public Guid ContentConsumerID
		{
			get
			{	return(guiContentConsumerID);   }
		}
		//-----------------------------------------------------------------	
		#endregion


		#region Methods
		//-----------------------------------------------------------------
		// Methods
		//-----------------------------------------------------------------		
		public abstract void InterceptMessage(ref Message msg);
		//-----------------------------------------------------------------		
		#endregion
	}

}