#region GNU_GPL
// Copyright (c) 2003 The Ohio State University
//
// Anish Arora <anish@cis.ohio-state.edu>
// Jason Hallstrom <hallstro@cis.ohio-state.edu>
// Bill Leal <leal@cis.ohio-state.edu>
//
// This file is part of DRSS.
//
// DRSS is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// DRSS is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with DRSS; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#endregion


using System;


namespace OSU.DRSS.Platform.Messaging
{
	
	[Serializable]
	public class MessageContentLayer
	{
		#region Fields
		//-----------------------------------------------------------------
		// Fields
		//-----------------------------------------------------------------		
		// The content contained within the layer
		private object objLayerContent;

		// The GUID corresponding to the layer's content provider
		private Guid guiContentProviderID;
		//-----------------------------------------------------------------
		#endregion
		
		
		#region Constructors
		//-----------------------------------------------------------------		
		// Constructors
		//-----------------------------------------------------------------		
		public MessageContentLayer(object objLayerContent, Guid guiContentProviderID)
		{
			this.objLayerContent = objLayerContent;
			this.guiContentProviderID = guiContentProviderID;
		}
		//-----------------------------------------------------------------		
		#endregion


		#region Properties
		//-----------------------------------------------------------------		
		// Properties
		//-----------------------------------------------------------------		
		public object LayerContent
		{
			get
			{	return(objLayerContent);   }
		}

		public Guid ContentProviderID
		{
			get
			{	return(guiContentProviderID);   }
		}
		//-----------------------------------------------------------------		
		#endregion


		#region Methods
		//-----------------------------------------------------------------
		// Methods
		//-----------------------------------------------------------------		
		public override string ToString()
		{	return("Content: [" + objLayerContent + "] ; Provider ID: [" + guiContentProviderID + "]");   }
		//-----------------------------------------------------------------		
		#endregion
	}

}
