#region GNU_GPL
// Copyright (c) 2003 The Ohio State University
//
// Anish Arora <anish@cis.ohio-state.edu>
// Jason Hallstrom <hallstro@cis.ohio-state.edu>
// Bill Leal <leal@cis.ohio-state.edu>
//
// This file is part of DRSS.
//
// DRSS is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// DRSS is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with DRSS; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#endregion


using System;
using System.Net;


namespace OSU.DRSS.Platform
{

	[Serializable]
	public class PlatformHostedObjectAddress
	{
		#region Fields
		//-----------------------------------------------------------------
		// Fields
		//-----------------------------------------------------------------		
		// The IP address and port number of the object's hosting platform
		private IPEndPoint ipePlatformIPEndPoint;
		
		// The GUID uniquely identifying the object
		private Guid guiObjectID;
		//-----------------------------------------------------------------
		#endregion


		#region Constructors
		//-----------------------------------------------------------------		
		// Constructors
		//-----------------------------------------------------------------		
		public PlatformHostedObjectAddress(IPEndPoint ipePlatformIPEndPoint, Guid guiObjectID)
		{
			this.ipePlatformIPEndPoint = ipePlatformIPEndPoint;
			this.guiObjectID = guiObjectID;
		}
		//-----------------------------------------------------------------		
		#endregion


		#region Properties
		//-----------------------------------------------------------------		
		// Properties
		//-----------------------------------------------------------------		
		public IPEndPoint PlatformIPEndPoint
		{
			get
			{	return(ipePlatformIPEndPoint);   }
		}

		public Guid ObjectID
		{
			get
			{	return(guiObjectID);   }
		}
		//-----------------------------------------------------------------		
		#endregion


		#region Methods
		//-----------------------------------------------------------------
		// Methods
		//-----------------------------------------------------------------		
		public override string ToString()
		{	return("Platform End-Point: [" + ipePlatformIPEndPoint + "] ; Object ID: [" + guiObjectID + "]");   }
		//-----------------------------------------------------------------		
		#endregion
	}

}
