#region GNU_GPL
// Copyright (c) 2003 The Ohio State University
//
// Anish Arora <anish@cis.ohio-state.edu>
// Jason Hallstrom <hallstro@cis.ohio-state.edu>
// Bill Leal <leal@cis.ohio-state.edu>
//
// This file is part of DRSS.
//
// DRSS is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// DRSS is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with DRSS; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#endregion


using System;
using OSU.DRSS.ManagedObjects;


namespace OSU.DRSS.Platform
{

	public delegate void StubSkeletonRegisteredEventDelegate(object objSource, StubSkeletonRegisteredEventArgs ssrArgs);


	[Serializable]
	public class StubSkeletonRegisteredEventArgs : EventArgs
	{
		#region Fields
		//-----------------------------------------------------------------
		// Fields
		//-----------------------------------------------------------------
		// The object information corresponding to the object that was registered
		private ManagedObjectInformation moiObjectInformation;	
		
		// The chain ID corresponding to the object's send-type interceptor chain
		private Guid guiSIChainID;

		// The chain ID corresponding to the objects receive-type interceptor chain
		private Guid guiRIChainID;
		//-----------------------------------------------------------------
		#endregion


		#region Constructors
		//-----------------------------------------------------------------		
		// Constructors
		//-----------------------------------------------------------------		
		public StubSkeletonRegisteredEventArgs(ManagedObjectInformation moiObjectInformation, Guid guiSIChainID, Guid guiRIChainID)
		{
			this.moiObjectInformation = moiObjectInformation;
			this.guiSIChainID = guiSIChainID;
			this.guiRIChainID = guiRIChainID;
		}
		//-----------------------------------------------------------------		
		#endregion


		#region Properties
		//-----------------------------------------------------------------		
		// Properties
		//-----------------------------------------------------------------	
		public ManagedObjectInformation ObjectInformation
		{
			get
			{	return(moiObjectInformation);   }
		}

		public Guid SIChainID
		{
			get
			{	return(guiSIChainID);   }
		}

		public Guid RIChainID
		{
			get
			{	return(guiRIChainID);   }
		}
		//-----------------------------------------------------------------	
		#endregion


		#region Methods
		//-----------------------------------------------------------------
		// Methods
		//-----------------------------------------------------------------		
		public override string ToString()
		{	
			string strResult = "Registered Object: [" + moiObjectInformation + "]; SI Chain ID: [" + guiSIChainID + "]; " +
																				  "RI Chain ID: [" + guiRIChainID + "]";
			return(strResult);   
		}
		//-----------------------------------------------------------------		
		#endregion
	}

}
