#region GNU_GPL
// Copyright (c) 2003 The Ohio State University
//
// Anish Arora <anish@cis.ohio-state.edu>
// Jason Hallstrom <hallstro@cis.ohio-state.edu>
// Bill Leal <leal@cis.ohio-state.edu>
//
// This file is part of DRSS.
//
// DRSS is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// DRSS is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with DRSS; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#endregion


using System;
using System.Threading;


namespace OSU.DRSS.Util
{

	public delegate void ThreadWithArgumentsStart(object objArgument);


	public class ThreadWithArgumentsFactory
	{

		private class RealThreadStart
		{
			#region Fields
			//-----------------------------------------------------------------
			// Fields
			//-----------------------------------------------------------------
			// The method (with arguments) to be run in a new thread
			private ThreadWithArgumentsStart twaStart;
			
			// The argument to pass to the method
			private object objArgument;
			//-----------------------------------------------------------------
			#endregion	


			#region Constructors
			//-----------------------------------------------------------------		
			// Constructors
			//-----------------------------------------------------------------		
			public RealThreadStart(ThreadWithArgumentsStart twaStart, object objArgument)
			{
				this.twaStart = twaStart;
				this.objArgument = objArgument;
			}
			//-----------------------------------------------------------------		
			#endregion


			#region Methods
			//-----------------------------------------------------------------
			// Methods
			//-----------------------------------------------------------------		
			public void Start()
			{	twaStart(objArgument);   }
			//-----------------------------------------------------------------		
			#endregion
		}
		

		#region Constructors
		//-----------------------------------------------------------------		
		// Constructors
		//-----------------------------------------------------------------		
		private ThreadWithArgumentsFactory()
		{}
		//-----------------------------------------------------------------		
		#endregion


		#region Methods
		//-----------------------------------------------------------------
		// Methods
		//-----------------------------------------------------------------		
		public static Thread CreateThread(ThreadWithArgumentsStart twaStart, object objArgument)
		{
			RealThreadStart rts = new RealThreadStart(twaStart, objArgument);
			return(new Thread(new ThreadStart(rts.Start)));
		}
		//-----------------------------------------------------------------		
		#endregion
	}

}
